; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    argcount MACRO args:VARARG
      LOCAL cnt
      cnt = 0
      FOR item, <args>
        cnt = cnt + 1
      ENDM
      EXITM %cnt                ;; return as a number
    ENDM

  ; *******************************

    cprint MACRO args:VARARG
      LOCAL alist,var
      bcnt = 0
   ;; ----------
      IFNDEF @@t
      .data
        @@t db 9,0                              ;; allocate tab if not defined
      .code
      ENDIF
   ;; ----------
      IFNDEF @@n
      .data
        @@n db 13,10,0                          ;; allocate line feed if not defined
      .code
      ENDIF
   ;; ----------
      alist equ <>
      var = 0
      FOR arg, <args>
        IF var EQ 0                             ;; append 1st arg to alist
          IFIDN <n>,<arg>
            alist CATSTR alist,<OFFSET @@n>
          ELSEIFIDN <t>,<arg>
            alist CATSTR alist,<OFFSET @@t>
          ELSE
            alist CATSTR alist,<reparg(arg)>
          ENDIF
        ELSEIF var GT 0                         ;; append comma seperated additional arguments
          IFIDN <n>,<arg>
            alist CATSTR alist,<,>,<OFFSET @@n>
          ELSEIFIDN <t>,<arg>
            alist CATSTR alist,<,>,<OFFSET @@t>
          ELSE
            alist CATSTR alist,<,>,<reparg(arg)>
          ENDIF
        ENDIF
        var = var + 1
      ENDM
   ;; ----------
      push esi
      mov esi, alloc(32768)
      invoke szMultiCat,argcount(args),esi,alist
      print esi
      free esi
      pop esi
    ENDM

  ; *******************************
    .code

start:
   
; 

    call main

    mov eax, input("Press enter to exit")

    exit

; 

main proc

    cls

    cprint n,n,t,"Hello World",n,n

    cprint t,"This is a test number ",ustr$(1),n, \
           t,"of the multiline 'cprint' macro",n, \
           t,"using abbreviated notation for",n,\
           t,"both 'tab' and 'newline' insertion",n,n

    ret

main endp

; 

end start
